module Collections

  ##
  # This class represents a context for select collections
  # where select all collections that *user* can see, including institutional collections
  class UserContext < Context

    def initialize(user)
      @user = user
    end

    def from
      institutions = @user.institutions
      ids = (institutions.blank?) ? @user.rid : @user.rid + ',' + institutions.map(&:id).join(',')

      sprintf "(SELECT FROM (select expand(in('BelongsTo')) from [%s]) WHERE @class = 'Collection')", ids
    end

  end
end
