module OrientDbSerializable
  extend ActiveSupport::Concern
  include OrientDb::Methods::SanitizableMethods

  def to_orientdb_hash
    hash = {'@class' => self.class.to_s}
    self.instance_variables.each do |var|
      var_name = sanitize_orientdb_vars(var)
      hash[var_name] = sanitize_orientdb_values(self.instance_variable_get(var))
    end
    hash.delete('id')

    excluded_orientdb_properties.each do |property|
      hash.delete(property.to_s)
    end

    # TODO: find a better way to ignore variables from ActiveModel
    hash.delete("validation_context")
    hash.delete("errors")
    hash
  end

  def excluded_orientdb_properties
    []
  end

end